//+------------------------------------------------------------------+
//|                                           3_Level_ZZ_Semafor.mq5 |
//|                                      Copyright 2000, asystem2000 |
//|                                            asystem2000@yandex.ru |
//+------------------------------------------------------------------+
//----  
#property copyright "2000, asystem2000"
//----    
#property link      "asystem2000@yandex.ru"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 6
//----    
#property indicator_plots   6
//+----------------------------------------------+
//|            |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_ARROW
//----      Aqua
#property indicator_color1  Aqua
//----    1  1
#property indicator_width1  1
//----     
#property indicator_label1  "Low"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_ARROW
//----      Magenta
#property indicator_color2  Magenta
//----    2  1
#property indicator_width2  1
//----     
#property indicator_label2 "High"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   3   
#property indicator_type3 DRAW_ARROW
//----       Aqua
#property indicator_color3  Aqua
//----    3  1
#property indicator_width3  1
//----     
#property indicator_label3  "Low"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   4   
#property indicator_type4 DRAW_ARROW
//----       Magenta
#property indicator_color4 Magenta
//----    4  1
#property indicator_width4  1
//----     
#property indicator_label4 "High"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   5   
#property indicator_type5 DRAW_ARROW
//----       Aqua
#property indicator_color5 Aqua 
//----    5  1
#property indicator_width5  1
//----     
#property indicator_label5  "Low"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   6   
#property indicator_type6 DRAW_ARROW
//----       Magenta
#property indicator_color6 Magenta
//----    4  1
#property indicator_width6  1
//----     
#property indicator_label6 "High"
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int Period1=5;
input int Deviation1=1;
input int Backstep1=3;
input int HighSymbol1=159;
input int LowSymbol1=159;

input int Period2=13;
input int Deviation2=8;
input int Backstep2=5;
input int HighSymbol2=108;
input int LowSymbol2=108;

input int Period3=34;
input int Deviation3=21;
input int Backstep3=12;
input int HighSymbol3=163;
input int LowSymbol3=163;
//+----------------------------------------------+
//----   ,   
//----      
double HighBuffer1[],LowBuffer1[];
double HighBuffer2[],LowBuffer2[];
double HighBuffer3[],LowBuffer3[]; 
//----      
int StartBar1,StartBar2,StartBar3,StartBar;
//----      
int Handle1,Handle2,Handle3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----  
   StartBar1=Period1+Deviation1+Backstep1+1;
   StartBar2=Period2+Deviation2+Backstep2+1;
   StartBar3=Period3+Deviation3+Backstep3+1;
   StartBar=(int)MathMax(StartBar1,MathMax(StartBar2,StartBar3));
   
//----      
   SetIndexBuffer(0,LowBuffer1,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,0);
//----      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"Low1");
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,LowSymbol1);
//----    ,   
   ArraySetAsSeries(LowBuffer1,true);

//----      
   SetIndexBuffer(1,HighBuffer1,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,0);
//----      DataWindow
   PlotIndexSetString(1,PLOT_LABEL,"High1");
//----   
   PlotIndexSetInteger(1,PLOT_ARROW,HighSymbol1);
//----    ,   
   ArraySetAsSeries(HighBuffer1,true);

//----      
   SetIndexBuffer(2,LowBuffer2,INDICATOR_DATA);
//----       3
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,0);
//----      DataWindow
   PlotIndexSetString(2,PLOT_LABEL,"Low2");
//----   
   PlotIndexSetInteger(2,PLOT_ARROW,LowSymbol2);
//----    ,   
   ArraySetAsSeries(LowBuffer2,true);

//----      
   SetIndexBuffer(3,HighBuffer2,INDICATOR_DATA);
//----       4
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,0);
//----      DataWindow
   PlotIndexSetString(3,PLOT_LABEL,"High2");
//----   
   PlotIndexSetInteger(3,PLOT_ARROW,HighSymbol2);
//----    ,   
   ArraySetAsSeries(HighBuffer2,true);

//----      
   SetIndexBuffer(4,LowBuffer3,INDICATOR_DATA);
//----       5
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,0);
//----      DataWindow
   PlotIndexSetString(4,PLOT_LABEL,"Low3");
//----   
   PlotIndexSetInteger(4,PLOT_ARROW,LowSymbol3);
//----    ,   
   ArraySetAsSeries(LowBuffer3,true);

//----      
   SetIndexBuffer(5,HighBuffer3,INDICATOR_DATA);
//----       6
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,0);
//----      DataWindow
   PlotIndexSetString(5,PLOT_LABEL,"High3");
//----   
   PlotIndexSetInteger(5,PLOT_ARROW,HighSymbol3);
//----    ,   
   ArraySetAsSeries(HighBuffer3,true);

//----      
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,"3_Level_ZZ_Semafor");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);

//----   
   Handle1=iCustom(NULL,0,"Examples\ZigZag",Period1,Deviation1,Backstep1);
   if(Handle1==INVALID_HANDLE) Print("      ZigZag1");
//----   
   Handle2=iCustom(NULL,0,"Examples\ZigZag",Period2,Deviation2,Backstep2);
   if(Handle2==INVALID_HANDLE) Print("      ZigZag2");
//----   
   Handle3=iCustom(NULL,0,"Examples\ZigZag",Period3,Deviation3,Backstep3);
   if(Handle3==INVALID_HANDLE) Print("      ZigZag3");
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //       
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  { 
//----       
   if(rates_total<StartBar) return(0);

//----    
   int limit,to_copy1,to_copy2,to_copy3;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=rates_total-StartBar;  //      
      to_copy1=rates_total;
      to_copy2=rates_total;
      to_copy3=rates_total;
     }
   else
     {
      limit=rates_total-prev_calculated;
      to_copy1=limit+StartBar1;
      to_copy2=limit+StartBar2;
      to_copy3=limit+StartBar3;
     }

//----       
      if(CopyBuffer(Handle1,1,0,to_copy1,HighBuffer1)<=0) return(0);
      if(CopyBuffer(Handle1,2,0,to_copy1,LowBuffer1)<=0) return(0);
      if(CopyBuffer(Handle2,1,0,to_copy2,HighBuffer2)<=0) return(0);
      if(CopyBuffer(Handle2,2,0,to_copy2,LowBuffer2)<=0) return(0);
      if(CopyBuffer(Handle3,1,0,to_copy3,HighBuffer3)<=0) return(0);
      if(CopyBuffer(Handle3,2,0,to_copy3,LowBuffer3)<=0) return(0);
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+